
#ifndef SCNSL__MY_TASK2_HH
#define SCNSL__MY_TASK2_HH



/// @file
/// Source node.


#include <systemc>


// Including the library:
#include <scnsl.hh>



class MyTask2 :
    public Scnsl::Rtl::RtlTask_if_t<8>
{

public:

    SC_HAS_PROCESS( MyTask2 );

    /// @brief Constructor.
    ///
    /// @param name This module name.
    /// @param id this module unique ID.
    /// @param n The node on which this task is placed.
    /// @param proxies The number of connected task proxies.
	/// @param scenario The number that represents the type of communication between tasks, as described in README.txt.
    /// @throw std::invalid_argument If proxies is zero.
    ///
	MyTask2( sc_core::sc_module_name name,
             const task_id_t id,
             Scnsl::Core::Node_t * n,
             const size_t proxies,
             const int scenario );

protected:

    /// @name Processes.
    //@{

    void writingProcess2();
    void writingProcess3();
    void writingProcess4();

    void readingProcess();

    void carrierProcess();
    //@}

private:

    MyTask2( MyTask2 & );

    MyTask2 & operator = ( MyTask2 & );

};

#endif

