 


#ifndef MySensingRouter_t_HH
#define MySensingRouter_t_HH

#include <systemc>
#include <scnsl.hh>
 
class MySensingRouter_t:
    public Scnsl::Tlm::TlmTask_if_t
{
public:

    SC_HAS_PROCESS( MySensingRouter_t );
    MySensingRouter_t( const sc_core::sc_module_name modulename,
              const task_id_t id,
              Scnsl::Core::Node_t * n,
              const size_t proxies );

    /// @brief Virtual destructor.
    virtual
    ~MySensingRouter_t();

    /// @name Inherited interface methods.
    //@{


    virtual
    void b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t );

    //@}

    /// @brief Signals when a packet is arrived.
    sc_core::sc_event _packetArrivedEvent;
    unsigned int taskid;
private:

    /// @name Processes.
    //@{

    /// @brief Sender process.
    void _sensing();
     void _routing();


    /// @brief Disabled copy constructor.
    MySensingRouter_t( const MySensingRouter_t & );

    /// @brief Disabled assignment operator.
    MySensingRouter_t & operator = ( MySensingRouter_t & );
};



#endif

